/*
 *      a t a n 2
 *
 *  calculates full four quadrant value of atan(y/x) for 
 * two numbers y and x, atan in range -pi <= atan < pi
 */

#define _LIBM_SOURCE

#include <math.h>
#include <stdio_h>
#include <string_h>
#include <stdlib_h>

#define EPSLN 1.0E-8 	/* convergence test value */

double atan2(y, x)
   double y, x;
{
   double ans,arg;
  
   if ((x == 0.0) && (y == 0.0))
      return (0.0);
   arg = fabs(y)/fabs(x);
   ans = atan(arg);
   if (x < 0.0)
 	ans = PI - ans;
   if (y < 0.0)
	ans = -ans;
   return (ans);
}

