/* gamma.c */

/* Computes gamma function (generalized factorial). Note that it is 
* very easy to exceed the numeric range of the machine. gamma(20)
*  = 2.4E18, and gamma(21) exceeds numeric range of MFFPF. gamma(33)
*  = 8.68E36 and gamma(100) = 9.3E155 . S E Peterson 3/92
*/ 

#define _LIBM_SOURCE

#include <math.h>

double gamma(x)
double x;

{
	if (x <= 0.0)
		return (-HUGE_VAL);
	return (exp(lgamma(x)));
}	

