/*
 *      T y p e . c
 *
 *  This function is called when it is required
 *  to find out a list type from its handle.
 *
 *
 * (c) Copyright 1996-1997 David J. Walker
 *     Email:  d.j.walker@x400.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  23 June 96  DJW   - First version
 *
 *  14 july 96  DJW   - Merged embedded function into this source file.
 */


#include <liblist.h>
#include "liblistx.h"


/*============================================================= LIST_TYPE */
extern
int   LIST_Type (list_t list)
/*    ~~~~~~~~~
 *	Report type of a list.
 *	Will follow level down for EMBEDDED lists.
 *------------------------------------------------------------------------*/
{
    LIBDEBUG ("LIST_Type", \
          "'list' parameter is not a valid list instance", \
          _LIST_ListCheck(list))

	if (LIST_Embedded(list))
	{
		list = ((_embedh_t)list)->self;
	}
    return (list->listclass->master->listtype);
}


/*========================================================== LIST_EMBEDDED */
extern
int     LIST_Embedded (list_t list)
/*      ~~~~~~~~~~~~~
 *  Report whether the list is part of an embedded list or not.
 *-------------------------------------------------------------------------*/
{
    LIBDEBUG ("LIST_Embedded", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListCheck(list))

    return (list->listclass->master->listtype == LIST_TYPE_EMBEDDED);
}


